Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.Designer.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.Designer.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.Designer.cs	(revision 17828)
@@ -249,5 +249,4 @@
       this.Name = "ExportJsonDialog";
       this.RightToLeft = System.Windows.Forms.RightToLeft.No;
-      this.ShowIcon = false;
       this.Text = "Export Json";
       this.groupBoxDetails.ResumeLayout(false);
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs	(revision 17828)
@@ -40,13 +40,15 @@
 
         Optimizer = content as IOptimizer;
-        Root = JsonItemConverter.Extract(Optimizer);
-        TreeNode parent = new TreeNode(Root.Name);
-        treeView.AfterCheck += TreeView_AfterCheck;
-        BuildTreeNode(parent, Root);
-        treeView.Nodes.Add(parent);
-        treeView.ExpandAll();
-        panelParameterDetails.Controls.Clear();
-        panelResultDetails.Controls.Clear();
-
+        if(Optimizer != null) {
+          Optimizer = (IOptimizer)Optimizer.Clone(); // clone the optimizer
+          Root = JsonItemConverter.Extract(Optimizer);
+          TreeNode parent = new TreeNode(Root.Name);
+          treeView.AfterCheck += TreeView_AfterCheck;
+          BuildTreeNode(parent, Root);
+          treeView.Nodes.Add(parent);
+          treeView.ExpandAll();
+          panelParameterDetails.Controls.Clear();
+          panelResultDetails.Controls.Clear();
+        }
       } 
     }
@@ -62,31 +64,22 @@
     public ExportJsonDialog() {
       InitializeComponent();
+      this.Icon = HeuristicLab.Common.Resources.HeuristicLab.Icon;
       InitCache();
     }
 
     private void exportButton_Click(object sender, EventArgs e) {
-      // to set default value for disabled items
-      JsonItemConverter.Inject(Optimizer, Root);
+      if (FolderBrowserDialog == null) {
+        FolderBrowserDialog = new FolderBrowserDialog();
+        FolderBrowserDialog.Description = "Select .json-Template Directory";
+      }
 
-      // clear all runs
-      Optimizer.Runs.Clear();
-
-      var validationResult = Root.GetValidator().Validate();
-      if (!validationResult.Success) {
-        IList<Exception> list = new List<Exception>();
-        //print faultyItems
-        foreach (var x in validationResult.Errors) {
-          list.Add(new Exception(x));
-        }
-        ErrorHandling.ShowErrorDialog(this, new AggregateException(list));
-      } else {
-        if (FolderBrowserDialog == null) {
-          FolderBrowserDialog = new FolderBrowserDialog();
-          FolderBrowserDialog.Description = "Select .json-Template Dictionary";
-        }
-
-        if (FolderBrowserDialog.ShowDialog() == DialogResult.OK) {
-          JsonTemplateGenerator.GenerateTemplate(FolderBrowserDialog.SelectedPath, textBoxTemplateName.Text, Optimizer, Root);
+      if (FolderBrowserDialog.ShowDialog() == DialogResult.OK) {
+        try {
+          JsonTemplateGenerator.GenerateTemplate(
+            Path.Combine(FolderBrowserDialog.SelectedPath, textBoxTemplateName.Text), 
+            Optimizer, Root);
           Close();
+        } catch (Exception ex) {
+          ErrorHandling.ShowErrorDialog(this, ex);
         }
       }
@@ -98,13 +91,10 @@
         foreach (var c in item.Children) {
           if (IsDrawableItem(c)) {
+            TreeNode childNode = new TreeNode(c.Name);
             if (c is IResultJsonItem) {
-              TreeNode childNode = new TreeNode(c.Name);
               treeViewResults.Nodes.Add(childNode);
-              RegisterItem(childNode, c, treeViewResults);
-              if(Node2VM.TryGetValue(childNode, out IJsonItemVM vm))
-                vm.Selected = true;
-              
+              IJsonItemVM vm = RegisterItem(childNode, c, treeViewResults);
+              if (vm != null) vm.Selected = true;              
             } else {
-              TreeNode childNode = new TreeNode(c.Name);
               node.Nodes.Add(childNode);
               BuildTreeNode(childNode, c);
@@ -115,6 +105,6 @@
     }
 
-    private void RegisterItem(TreeNode node, IJsonItem item, TreeView tv) {
-      if (JI2VM.TryGetValue(item.GetType(), out Type vmType)) { // TODO: enhance for interfaces?
+    private IJsonItemVM RegisterItem(TreeNode node, IJsonItem item, TreeView tv) {
+      if (JI2VM.TryGetValue(item.GetType(), out Type vmType)) {
         IJsonItemVM vm = (IJsonItemVM)Activator.CreateInstance(vmType);
 
@@ -128,8 +118,10 @@
         UserControl control = new JsonItemBaseControl(vm, vm.Control);
         Node2Control.Add(node, control);
+        return vm;
       } else {
         node.ForeColor = Color.LightGray;
         node.NodeFont = new Font(SystemFonts.DialogFont, FontStyle.Italic);
       }
+      return null;
     }
 
@@ -142,5 +134,5 @@
       }
       
-      return b || !(item is EmptyJsonItem);
+      return b || !(item is EmptyJsonItem) || !(item is UnsupportedJsonItem);
     }
     
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ValueLookupJsonItemControl.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ValueLookupJsonItemControl.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ValueLookupJsonItemControl.cs	(revision 17828)
@@ -11,8 +11,8 @@
 
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
-  public partial class ValueLookupJsonItemControl : LookupJsonItemControl {
+  public partial class ValueLookupJsonItemControl : UserControl {
     private static IDictionary<Type, Type> JI2VM { get; set; }
 
-    public ValueLookupJsonItemControl(IValueLookupJsonItemVM vm) : base(vm) {
+    public ValueLookupJsonItemControl(IValueLookupJsonItemVM vm) {
       InitializeComponent();
       InitCache();
@@ -22,7 +22,8 @@
         content.Controls.Clear();
         UserControl control = tmp.Control;
-        content.Controls.Add(control);
-        control.Dock = DockStyle.Fill;
-        
+        if(control != null) {
+          content.Controls.Add(control);
+          control.Dock = DockStyle.Fill;
+        }
       }
     }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/AlgorithmConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/AlgorithmConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/AlgorithmConverter.cs	(revision 17828)
@@ -12,4 +12,7 @@
 
     public override Type ConvertableType => typeof(IAlgorithm);
+
+    public override bool CanConvertType(Type t) => 
+      t.GetInterfaces().Any(x => x == ConvertableType);
 
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/BaseConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/BaseConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/BaseConverter.cs	(revision 17828)
@@ -12,4 +12,7 @@
   {
     public abstract int Priority { get; }
+
+    public abstract bool CanConvertType(Type t);
+
     public abstract Type ConvertableType { get; }
 
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/BatchRunConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/BatchRunConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/BatchRunConverter.cs	(revision 17828)
@@ -10,4 +10,6 @@
     public override int Priority => 10;
     public override Type ConvertableType => HEAL.Attic.Mapper.StaticCache.GetType(new Guid("E85407E0-18EC-4198-8321-9CF030FDF6D7"));
+
+    public override bool CanConvertType(Type t) => ConvertableType.IsAssignableFrom(t);
 
     public override IJsonItem Extract(IItem value, IJsonItemConverter root) {
@@ -31,5 +33,4 @@
         Maximum = int.MaxValue 
       });
-      
       return batchRunJI;
     }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ConstrainedValueParameterConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ConstrainedValueParameterConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ConstrainedValueParameterConverter.cs	(revision 17828)
@@ -11,4 +11,7 @@
     public override int Priority => 3;
     public override Type ConvertableType => typeof(IConstrainedValueParameter<>);
+
+    public override bool CanConvertType(Type t) =>
+      t.GetInterfaces().Any(x => x.IsGenericType && x.GetGenericTypeDefinition() == typeof(IConstrainedValueParameter<>));
 
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/EnumTypeConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/EnumTypeConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/EnumTypeConverter.cs	(revision 17828)
@@ -11,4 +11,8 @@
     public override int Priority => 1;
     public override Type ConvertableType => typeof(EnumValue<>);
+
+    public override bool CanConvertType(Type t) =>
+      typeof(EnumValue<>).IsAssignableFrom(t) || 
+      (t.IsGenericType && t.GetGenericTypeDefinition() == ConvertableType);
 
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) =>
@@ -25,5 +29,5 @@
         Value = Enum.GetName(enumType, val),
         ConcreteRestrictedItems = Enum.GetNames(enumType)
-    };
+      };
     }
   }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ExperimentConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ExperimentConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ExperimentConverter.cs	(revision 17828)
@@ -11,4 +11,7 @@
     public override int Priority => 10;
     public override Type ConvertableType => HEAL.Attic.Mapper.StaticCache.GetType(new Guid("A8A4536B-54C1-4A17-AB58-A6006F7F394B"));
+
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
 
     public override IJsonItem Extract(IItem value, IJsonItemConverter root) {
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/LookupParameterConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/LookupParameterConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/LookupParameterConverter.cs	(revision 17828)
@@ -10,5 +10,8 @@
     public override int Priority => 3;
     public override Type ConvertableType => typeof(ILookupParameter);
-    
+
+    public override bool CanConvertType(Type t) =>
+      t.GetInterfaces().Any(x => x == typeof(ILookupParameter));
+
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) =>
       ((ILookupParameter)item).ActualName = ((ILookupJsonItem)data).ActualName as string;
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/MultiCheckedOperatorConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/MultiCheckedOperatorConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/MultiCheckedOperatorConverter.cs	(revision 17828)
@@ -10,6 +10,10 @@
   public class MultiCheckedOperatorConverter : ParameterizedItemConverter {
     public override int Priority => 3;
+
     public override Type ConvertableType => typeof(ICheckedMultiOperator<>);
-    
+
+    public override bool CanConvertType(Type t) =>
+      t.GetInterfaces().Any(x => x.IsGenericType && x.GetGenericTypeDefinition() == ConvertableType);
+
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
       base.Inject(item, data, root);
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ParameterizedItemConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ParameterizedItemConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ParameterizedItemConverter.cs	(revision 17828)
@@ -10,4 +10,7 @@
     public override int Priority => 2;
     public override Type ConvertableType => typeof(IParameterizedItem);
+
+    public override bool CanConvertType(Type t) =>
+      t.GetInterfaces().Any(x => x == typeof(IParameterizedItem));
 
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
@@ -39,4 +42,5 @@
       return item;
     }
+
   }
 }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/RegressionProblemDataConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/RegressionProblemDataConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/RegressionProblemDataConverter.cs	(revision 17828)
@@ -34,4 +34,7 @@
     public override Type ConvertableType => HEAL.Attic.Mapper.StaticCache.GetType(new Guid("EE612297-B1AF-42D2-BF21-AF9A2D42791C"));
 
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
+
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
 
@@ -180,27 +183,27 @@
         if(it != null) {
           if(it.MoveNext() && it.Current is double) {
-            CreateMatrix(dict, out IList<string> rowNames, out double[][] mat);
+            CreateMatrix(dict, out IList<string> columnNames, out double[][] mat);
             return new DoubleMatrixJsonItem() {
               Name = Dataset,
               Value = mat,
-              RowNames = rowNames,
+              ColumnNames = columnNames,
               Minimum = double.MinValue,
               Maximum = double.MaxValue
             };
           } else if(it.Current is int) {
-            CreateMatrix(dict, out IList<string> rowNames, out int[][] mat);
+            CreateMatrix(dict, out IList<string> columnNames, out int[][] mat);
             return new IntMatrixJsonItem() {
               Name = Dataset,
               Value = mat,
-              RowNames = rowNames,
+              ColumnNames = columnNames,
               Minimum = int.MinValue,
               Maximum = int.MaxValue
             };
           } else if (it.Current is bool) {
-            CreateMatrix(dict, out IList<string> rowNames, out bool[][] mat);
+            CreateMatrix(dict, out IList<string> columnNames, out bool[][] mat);
             return new BoolMatrixJsonItem() {
               Name = Dataset,
               Value = mat,
-              RowNames = rowNames
+              ColumnNames = columnNames
             };
           }
@@ -210,17 +213,17 @@
     }
     
-    private void CreateMatrix<T>(Dictionary<string, IList> dict, out IList<string> rowNames, out T[][] matrix) {
+    private void CreateMatrix<T>(Dictionary<string, IList> dict, out IList<string> columnNames, out T[][] matrix) {
       int cols = dict.Count, rows = 0, c = 0;
-      rowNames = new List<string>();
+      columnNames = new List<string>();
       matrix = new T[cols][];
       foreach (var x in dict) {
         rows = Math.Max(rows, x.Value.Count);
-        rowNames.Add(x.Key);
+        columnNames.Add(x.Key);
 
         matrix[c] = new T[rows];
+
         int r = 0;
-
-        foreach (var rowValue in x.Value) {
-          matrix[c][r] = (T)rowValue;
+        foreach (var callValue in x.Value) {
+          matrix[c][r] = (T)callValue;
           ++r;
         }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ResultParameterConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ResultParameterConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ResultParameterConverter.cs	(revision 17828)
@@ -12,4 +12,7 @@
 
     public override Type ConvertableType => typeof(IResultParameter);
+
+    public override bool CanConvertType(Type t) =>
+      t.GetInterfaces().Any(x => x == typeof(IResultParameter));
 
     public override IJsonItem Extract(IItem value, IJsonItemConverter root) {
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/StringValueConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/StringValueConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/StringValueConverter.cs	(revision 17828)
@@ -12,4 +12,7 @@
     public override Type ConvertableType => typeof(StringValue);
 
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
+
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) =>
       ((StringValue)item).Value = ((StringJsonItem)data).Value;
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueLookupParameterConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueLookupParameterConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueLookupParameterConverter.cs	(revision 17828)
@@ -10,4 +10,7 @@
     public override int Priority => 4;
     public override Type ConvertableType => typeof(IValueLookupParameter);
+
+    public override bool CanConvertType(Type t) =>
+      t.GetInterfaces().Any(x => x == typeof(IValueLookupParameter));
 
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueParameterConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueParameterConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueParameterConverter.cs	(revision 17828)
@@ -10,4 +10,7 @@
     public override int Priority => 2;
     public override Type ConvertableType => typeof(IValueParameter);
+
+    public override bool CanConvertType(Type t) =>
+      t.GetInterfaces().Any(x => x == typeof(IValueParameter));
 
     public override void Inject(IItem value, IJsonItem data, IJsonItemConverter root) {
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueRangeConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueRangeConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueRangeConverter.cs	(revision 17828)
@@ -14,4 +14,7 @@
     public override int Priority => 1;
     public override Type ConvertableType => typeof(IntRange);
+
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
 
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
@@ -39,4 +42,7 @@
     public override Type ConvertableType => typeof(DoubleRange);
 
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
+
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
       DoubleRange range = item as DoubleRange;
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueTypeArrayConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueTypeArrayConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueTypeArrayConverter.cs	(revision 17828)
@@ -13,4 +13,7 @@
     public override int Priority => 1;
     public override Type ConvertableType => typeof(IntArray);
+
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
 
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
@@ -39,4 +42,7 @@
     public override Type ConvertableType => typeof(DoubleArray);
 
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
+
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
       DoubleArray arr = item as DoubleArray;
@@ -63,4 +69,7 @@
     public override int Priority => 2;
     public override Type ConvertableType => typeof(PercentArray);
+
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
 
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
@@ -89,4 +98,7 @@
     public override Type ConvertableType => typeof(BoolArray);
 
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
+
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
       BoolArray arr = item as BoolArray;
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueTypeMatrixConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueTypeMatrixConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueTypeMatrixConverter.cs	(revision 17828)
@@ -12,4 +12,5 @@
     public override int Priority => 1;
     public override Type ConvertableType => typeof(IntMatrix);
+
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
       IntMatrix mat = item as IntMatrix;
@@ -92,5 +93,15 @@
     where T : struct 
   {
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
+
     #region Helper
+    /// <summary>
+    /// Copies the data into the matrix object. Uses reflection to set the
+    /// row and column size of the matrix, because it is not possible to
+    /// create a new matrix at this point and there exists no public resize method.
+    /// </summary>
+    /// <param name="matrix"></param>
+    /// <param name="data"></param>
     protected void CopyMatrixData(MatrixType matrix, T[][] data) {
       var cols = data.Length;
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueTypeValueConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueTypeValueConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueTypeValueConverter.cs	(revision 17828)
@@ -12,4 +12,7 @@
     public override int Priority => 1;
     public override Type ConvertableType => typeof(IntValue);
+
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
 
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) =>
@@ -30,4 +33,7 @@
     public override Type ConvertableType => typeof(DoubleValue);
 
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
+
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) =>
       ((DoubleValue)item).Value = ((DoubleJsonItem)data).Value;
@@ -46,4 +52,7 @@
     public override int Priority => 2;
     public override Type ConvertableType => typeof(PercentValue);
+
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
 
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) =>
@@ -64,4 +73,7 @@
     public override Type ConvertableType => typeof(BoolValue);
 
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
+
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) =>
       ((BoolValue)item).Value = ((BoolJsonItem)data).Value;
@@ -79,4 +91,7 @@
     public override Type ConvertableType => typeof(DateTimeValue);
 
+    public override bool CanConvertType(Type t) =>
+      ConvertableType.IsAssignableFrom(t);
+
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) =>
       ((DateTimeValue)item).Value = ((DateTimeJsonItem)data).Value;
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IConcreteRestrictedJsonItem.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IConcreteRestrictedJsonItem.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IConcreteRestrictedJsonItem.cs	(revision 17828)
@@ -1,8 +1,9 @@
-﻿using System.Collections.Generic;
+﻿using System.Collections;
+using System.Collections.Generic;
 
 namespace HeuristicLab.JsonInterface {
   public interface IConcreteRestrictedJsonItem<T> : IJsonItem {
     /// <summary>
-    /// The item, 
+    /// array of restricted items
     /// </summary>
     IEnumerable<T> ConcreteRestrictedItems { get; set; }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IJsonItemConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IJsonItemConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IJsonItemConverter.cs	(revision 17828)
@@ -29,4 +29,11 @@
     /// </summary>
     int Priority { get; }
+
+    /// <summary>
+    /// Checks if the given type can be converted.
+    /// </summary>
+    /// <param name="t"></param>
+    /// <returns></returns>
+    bool CanConvertType(Type t);
   }
 }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JsonItemConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JsonItemConverter.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JsonItemConverter.cs	(revision 17828)
@@ -22,4 +22,6 @@
 
     public Type ConvertableType => throw new NotImplementedException();
+
+    public bool CanConvertType(Type t) => throw new NotImplementedException();
     #endregion
 
@@ -32,7 +34,9 @@
       IList<IJsonItemConverter> possibleConverters = new List<IJsonItemConverter>();
       
-      foreach (var x in Converters)
-        if (CompareTypes(type, x.Key))
+      foreach (var x in Converters) {
+        if (x.Value.CanConvertType(type))
           possibleConverters.Add(x.Value);
+      }
+        
 
       if(possibleConverters.Count > 0) {
@@ -61,5 +65,6 @@
       else {
         IJsonItemConverter converter = GetConverter(item.GetType());
-        if (converter == null) return new UnsupportedJsonItem();
+        if (converter == null) 
+          return new UnsupportedJsonItem() { Name = $"{item.ItemName} (unsupported)" };
         IJsonItem tmp = converter.Extract(item, root);
         ExtractCache.Add(hash, tmp);
@@ -84,15 +89,4 @@
       Converters = converters;
     }
-
-    private bool CompareGenericTypes(Type t1, Type t2) =>
-      (t1.IsGenericType && t1.GetGenericTypeDefinition() == t2) /*||
-      (t2.IsGenericType && t2.GetGenericTypeDefinition() == t1)*/;
-
-    private bool CompareTypes(Type t1, Type t2) =>
-      t1 == t2 || /*t1.IsAssignableFrom(t2) ||*/
-      t1.GetInterfaces().Any(
-        i => i == t2 || CompareGenericTypes(i, t2)
-      ) ||
-      CompareGenericTypes(t1, t2);
   }
 }
